/[gentoo-x86]/eclass/haskell-cabal.eclass
Gentoo

Diff of /eclass/haskell-cabal.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.18 Revision 1.31
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.18 2010/01/26 20:50:40 kolmodin Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.31 2012/04/14 20:22:23 slyfox Exp $
4# 4
5# @ECLASS: haskell-cabal.eclass
6# @MAINTAINER:
7# Haskell herd <haskell@gentoo.org>
8# @AUTHOR:
5# Original authors: Andres Loeh <kosmikus@gentoo.org> 9# Original author: Andres Loeh <kosmikus@gentoo.org>
6# Duncan Coutts <dcoutts@gentoo.org> 10# Original author: Duncan Coutts <dcoutts@gentoo.org>
7# Maintained by: Haskell herd <haskell@gentoo.org> 11# @BLURB: for packages that make use of the Haskell Common Architecture for Building Applications and Libraries (cabal)
8# 12# @DESCRIPTION:
9# This eclass is for packages that make use of the
10# Haskell Common Architecture for Building Applications
11# and Libraries (cabal).
12#
13# Basic instructions: 13# Basic instructions:
14# 14#
15# Before inheriting the eclass, set CABAL_FEATURES to 15# Before inheriting the eclass, set CABAL_FEATURES to
16# reflect the tools and features that the package makes 16# reflect the tools and features that the package makes
17# use of. 17# use of.
18# 18#
19# Currently supported features: 19# Currently supported features:
20# haddock -- for documentation generation 20# haddock -- for documentation generation
21# hscolour -- generation of colourised sources
21# alex -- lexer/scanner generator 22# alex -- lexer/scanner generator
22# happy -- parser generator 23# happy -- parser generator
23# c2hs -- C interface generator 24# c2hs -- C interface generator
24# cpphs -- C preprocessor clone written in Haskell 25# cpphs -- C preprocessor clone written in Haskell
25# profile -- if package supports to build profiling-enabled libraries 26# profile -- if package supports to build profiling-enabled libraries
26# bootstrap -- only used for the cabal package itself 27# bootstrap -- only used for the cabal package itself
27# bin -- the package installs binaries 28# bin -- the package installs binaries
28# lib -- the package installs libraries 29# lib -- the package installs libraries
29# nocabaldep -- don't add dependency on cabal. 30# nocabaldep -- don't add dependency on cabal.
30# only used for packages that _must_ not pull the dependency 31# only used for packages that _must_ not pull the dependency
31# on cabal, but still use this eclass (e.g. haskell-updater). 32# on cabal, but still use this eclass (e.g. haskell-updater).
32#
33# Dependencies on other cabal packages have to be specified
34# correctly.
35#
36# Cabal libraries should usually be SLOTted with "${PV}".
37#
38# Many Cabal packages require S to be manually set.
39#
40# Conforming Cabal packages don't require any function definitions
41# in the ebuild.
42#
43# Special flags to Cabal Configure can now be set by using
44# CABAL_CONFIGURE_FLAGS
45 33
46inherit ghc-package multilib 34inherit ghc-package multilib
47 35
36# @ECLASS-VARIABLE: CABAL_EXTRA_CONFIGURE_FLAGS
37# @DESCRIPTION:
38# User-specified additional parameters passed to 'setup configure'.
39# example: /etc/make.conf: CABAL_EXTRA_CONFIGURE_FLAGS=--enable-shared
40: ${CABAL_EXTRA_CONFIGURE_FLAGS:=}
41
42# @ECLASS-VARIABLE: CABAL_EXTRA_BUILD_FLAGS
43# @DESCRIPTION:
44# User-specified additional parameters passed to 'setup build'.
45# example: /etc/make.conf: CABAL_EXTRA_BUILD_FLAGS=-v
46: ${CABAL_EXTRA_BUILD_FLAGS:=}
47
48# @ECLASS-VARIABLE: GHC_BOOTSTRAP_FLAGS
49# @DESCRIPTION:
50# User-specified additional parameters for ghc when building
51# _only_ 'setup' binary bootstrap.
52# example: /etc/make.conf: GHC_BOOTSTRAP_FLAGS=-dynamic to make
53# linking 'setup' faster.
54: ${GHC_BOOTSTRAP_FLAGS:=}
55
56HASKELL_CABAL_EXPF="pkg_setup src_compile src_test src_install"
57
58case "${EAPI:-0}" in
59 2|3|4) HASKELL_CABAL_EXPF+=" src_configure" ;;
60 *) ;;
61esac
62
63EXPORT_FUNCTIONS ${HASKELL_CABAL_EXPF}
48 64
49for feature in ${CABAL_FEATURES}; do 65for feature in ${CABAL_FEATURES}; do
50 case ${feature} in 66 case ${feature} in
51 haddock) CABAL_USE_HADDOCK=yes;; 67 haddock) CABAL_USE_HADDOCK=yes;;
68 hscolour) CABAL_USE_HSCOLOUR=yes;;
69 hoogle) CABAL_USE_HOOGLE=yes;;
52 alex) CABAL_USE_ALEX=yes;; 70 alex) CABAL_USE_ALEX=yes;;
53 happy) CABAL_USE_HAPPY=yes;; 71 happy) CABAL_USE_HAPPY=yes;;
54 c2hs) CABAL_USE_C2HS=yes;; 72 c2hs) CABAL_USE_C2HS=yes;;
55 cpphs) CABAL_USE_CPPHS=yes;; 73 cpphs) CABAL_USE_CPPHS=yes;;
56 profile) CABAL_USE_PROFILE=yes;; 74 profile) CABAL_USE_PROFILE=yes;;
62 esac 80 esac
63done 81done
64 82
65if [[ -n "${CABAL_USE_HADDOCK}" ]]; then 83if [[ -n "${CABAL_USE_HADDOCK}" ]]; then
66 IUSE="${IUSE} doc" 84 IUSE="${IUSE} doc"
85 # don't require depend on itself to build docs.
86 # ebuild bootstraps docs from just built binary
87 [[ ${CATEGORY}/${PN} = "dev-haskell/haddock" ]] || DEPEND="${DEPEND} doc? ( dev-haskell/haddock )"
88fi
89
90if [[ -n "${CABAL_USE_HSCOLOUR}" ]]; then
91 IUSE="${IUSE} hscolour"
67 DEPEND="${DEPEND} doc? ( dev-haskell/haddock )" 92 DEPEND="${DEPEND} hscolour? ( dev-haskell/hscolour )"
68fi 93fi
69 94
70if [[ -n "${CABAL_USE_ALEX}" ]]; then 95if [[ -n "${CABAL_USE_ALEX}" ]]; then
71 DEPEND="${DEPEND} dev-haskell/alex" 96 DEPEND="${DEPEND} dev-haskell/alex"
72 cabalconf="${cabalconf} --with-alex=/usr/bin/alex"
73fi 97fi
74 98
75if [[ -n "${CABAL_USE_HAPPY}" ]]; then 99if [[ -n "${CABAL_USE_HAPPY}" ]]; then
76 DEPEND="${DEPEND} dev-haskell/happy" 100 DEPEND="${DEPEND} dev-haskell/happy"
77 cabalconf="${cabalconf} --with-happy=/usr/bin/happy"
78fi 101fi
79 102
80if [[ -n "${CABAL_USE_C2HS}" ]]; then 103if [[ -n "${CABAL_USE_C2HS}" ]]; then
81 DEPEND="${DEPEND} dev-haskell/c2hs" 104 DEPEND="${DEPEND} dev-haskell/c2hs"
82 cabalconf="${cabalconf} --with-c2hs=/usr/bin/c2hs"
83fi 105fi
84 106
85if [[ -n "${CABAL_USE_CPPHS}" ]]; then 107if [[ -n "${CABAL_USE_CPPHS}" ]]; then
86 DEPEND="${DEPEND} dev-haskell/cpphs" 108 DEPEND="${DEPEND} dev-haskell/cpphs"
87 cabalconf="${cabalconf} --with-cpphs=/usr/bin/cpphs"
88fi 109fi
89 110
90if [[ -n "${CABAL_USE_PROFILE}" ]]; then 111if [[ -n "${CABAL_USE_PROFILE}" ]]; then
91 IUSE="${IUSE} profile" 112 IUSE="${IUSE} profile"
92fi 113fi
112 if [[ "${CABAL_BOOTSTRAP}" ]]; then 133 if [[ "${CABAL_BOOTSTRAP}" ]]; then
113 # We're bootstrapping cabal, so the cabal version is the version 134 # We're bootstrapping cabal, so the cabal version is the version
114 # of this package itself. 135 # of this package itself.
115 _CABAL_VERSION_CACHE="${PV}" 136 _CABAL_VERSION_CACHE="${PV}"
116 elif [[ "${CABAL_FROM_GHC}" ]]; then 137 elif [[ "${CABAL_FROM_GHC}" ]]; then
117 # We can't assume there's a version of Cabal installed by ebuild as 138 local cabal_package=$(echo "$(ghc-libdir)"/Cabal-*)
118 # this might be a first time install of GHC (for packages that 139 # /path/to/ghc/Cabal-${VER} -> ${VER}
119 # use the shipped Cabal like haskell-updater). 140 _CABAL_VERSION_CACHE="${cabal_package/*Cabal-/}"
120
121 # The user is likely to only have one version of Cabal, provided
122 # by GHC. Note that dev-haskell/cabal can be a dummy package, only
123 # using the version provided by GHC. If the user has another version
124 # of Cabal too (more recent than the one GHC provides through
125 # dev-haskell/cabal, or possibly older if he used an old
126 # Cabal package) the most recent is used (expected to be the last
127 # one in the ghc-pkg output).
128 _CABAL_VERSION_CACHE="$(ghc-pkg field Cabal version | tail -n 1)"
129
130 # Strip out the "version: " prefix
131 _CABAL_VERSION_CACHE="${_CABAL_VERSION_CACHE#"version: "}"
132 else 141 else
133 # We ask portage, not ghc, so that we only pick up 142 # We ask portage, not ghc, so that we only pick up
134 # portage-installed cabal versions. 143 # portage-installed cabal versions.
135 _CABAL_VERSION_CACHE="$(ghc-extractportageversion dev-haskell/cabal)" 144 _CABAL_VERSION_CACHE="$(ghc-extractportageversion dev-haskell/cabal)"
136 fi 145 fi
141cabal-bootstrap() { 150cabal-bootstrap() {
142 local setupmodule 151 local setupmodule
143 local cabalpackage 152 local cabalpackage
144 if [[ -f "${S}/Setup.lhs" ]]; then 153 if [[ -f "${S}/Setup.lhs" ]]; then
145 setupmodule="${S}/Setup.lhs" 154 setupmodule="${S}/Setup.lhs"
146 else
147 if [[ -f "${S}/Setup.hs" ]]; then 155 elif [[ -f "${S}/Setup.hs" ]]; then
148 setupmodule="${S}/Setup.hs" 156 setupmodule="${S}/Setup.hs"
149 else 157 else
150 die "No Setup.lhs or Setup.hs found" 158 die "No Setup.lhs or Setup.hs found"
151 fi 159 fi
160
161 if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]] && ! ghc-sanecabal "${CABAL_MIN_VERSION}"; then
162 eerror "The package dev-haskell/cabal is not correctly installed for"
163 eerror "the currently active version of ghc ($(ghc-version)). Please"
164 eerror "run haskell-updater or re-build dev-haskell/cabal."
165 die "cabal is not correctly installed"
152 fi 166 fi
153 167
154 # We build the setup program using the latest version of 168 # We build the setup program using the latest version of
155 # cabal that we have installed 169 # cabal that we have installed
156 if version_is_at_least "6.4" "$(ghc-version)"; then
157 cabalpackage=Cabal-$(cabal-version) 170 cabalpackage=Cabal-$(cabal-version)
158 else
159 # older ghc's don't support package versioning
160 cabalpackage=Cabal
161 fi
162 einfo "Using cabal-$(cabal-version)." 171 einfo "Using cabal-$(cabal-version)."
172
173 make_setup() {
163 $(ghc-getghc) -package "${cabalpackage}" --make "${setupmodule}" -o setup \ 174 set -- -package "${cabalpackage}" --make "${setupmodule}" \
175 ${GHC_BOOTSTRAP_FLAGS} \
176 "$@" \
177 -o setup
178 echo $(ghc-getghc) ${HCFLAGS} "$@"
179 $(ghc-getghc) "$@"
180 }
181 if $(ghc-supports-shared-libraries); then
182 # # some custom build systems might use external libraries,
183 # # for which we don't have shared libs, so keep static fallback
184 # Disabled '-dynamic' as ghc does not embed RPATH to used extra-libraries:
185 # bug #411789, http://hackage.haskell.org/trac/ghc/ticket/5743#comment:3
186 # make_setup -dynamic "$@" ||
164 || die "compiling ${setupmodule} failed" 187 make_setup "$@" || die "compiling ${setupmodule} failed"
188 else
189 make_setup "$@" || die "compiling ${setupmodule} failed"
190 fi
165} 191}
166 192
167cabal-mksetup() { 193cabal-mksetup() {
168 local setupdir 194 local setupdir
169 195
174 fi 200 fi
175 201
176 rm -f "${setupdir}"/Setup.{lhs,hs} 202 rm -f "${setupdir}"/Setup.{lhs,hs}
177 203
178 echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \ 204 echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \
179 > $setupdir/Setup.hs 205 > $setupdir/Setup.hs || die "failed to create default Setup.hs"
206}
207
208cabal-hscolour() {
209 set -- hscolour "$@"
210 echo ./setup "$@"
211 ./setup "$@" || die "setup hscolour failed"
180} 212}
181 213
182cabal-haddock() { 214cabal-haddock() {
183 ./setup haddock || die "setup haddock failed" 215 set -- haddock "$@"
216 echo ./setup "$@"
217 ./setup "$@" || die "setup haddock failed"
218}
219
220cabal-hscolour-haddock() {
221 # --hyperlink-source implies calling 'setup hscolour'
222 set -- haddock --hyperlink-source
223 echo ./setup "$@"
224 ./setup "$@" --hyperlink-source || die "setup haddock --hyperlink-source failed"
184} 225}
185 226
186cabal-configure() { 227cabal-configure() {
228 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
229
187 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then 230 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
188 cabalconf="${cabalconf} --with-haddock=/usr/bin/haddock" 231 cabalconf="${cabalconf} --with-haddock=${EPREFIX}/usr/bin/haddock"
189 fi 232 fi
190 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then 233 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then
191 cabalconf="${cabalconf} --enable-library-profiling" 234 cabalconf="${cabalconf} --enable-library-profiling"
192 fi 235 fi
236 if [[ -n "${CABAL_USE_ALEX}" ]]; then
237 cabalconf="${cabalconf} --with-alex=${EPREFIX}/usr/bin/alex"
238 fi
239
240 if [[ -n "${CABAL_USE_HAPPY}" ]]; then
241 cabalconf="${cabalconf} --with-happy=${EPREFIX}/usr/bin/happy"
242 fi
243
244 if [[ -n "${CABAL_USE_C2HS}" ]]; then
245 cabalconf="${cabalconf} --with-c2hs=${EPREFIX}/usr/bin/c2hs"
246 fi
247 if [[ -n "${CABAL_USE_CPPHS}" ]]; then
248 cabalconf="${cabalconf} --with-cpphs=${EPREFIX}/usr/bin/cpphs"
249 fi
250
251 local option
252 for option in ${HCFLAGS}
253 do
254 cabalconf+=" --ghc-option=$option"
255 done
256
193 # Building GHCi libs on ppc64 causes "TOC overflow". 257 # Building GHCi libs on ppc64 causes "TOC overflow".
194 if use ppc64; then 258 if use ppc64; then
195 cabalconf="${cabalconf} --disable-library-for-ghci" 259 cabalconf="${cabalconf} --disable-library-for-ghci"
196 fi 260 fi
197 261
198 if version_is_at_least "1.4" "$(cabal-version)"; then 262 # currently cabal does not respect CFLAGS and LDFLAGS on it's own (bug #333217)
263 # so translate LDFLAGS to ghc parameters (without filtering)
264 local flag
265 for flag in $LDFLAGS; do cabalconf="${cabalconf} --ghc-option=-optl$flag"; done
266
199 # disable executable stripping for the executables, as portage will 267 # disable executable stripping for the executables, as portage will
200 # strip by itself, and pre-stripping gives a QA warning. 268 # strip by itself, and pre-stripping gives a QA warning.
201 # cabal versions previous to 1.4 does not strip executables, and does 269 # cabal versions previous to 1.4 does not strip executables, and does
202 # not accept the flag. 270 # not accept the flag.
203 # this fixes numerous bugs, amongst them; 271 # this fixes numerous bugs, amongst them;
204 # bug #251881, bug #251882, bug #251884, bug #251886, bug #299494 272 # bug #251881, bug #251882, bug #251884, bug #251886, bug #299494
205 cabalconf="${cabalconf} --disable-executable-stripping" 273 cabalconf="${cabalconf} --disable-executable-stripping"
206 fi
207 274
208 if version_is_at_least "1.2.0" "$(cabal-version)"; then
209 cabalconf="${cabalconf} --docdir=/usr/share/doc/${PF}" 275 cabalconf="${cabalconf} --docdir=${EPREFIX}/usr/share/doc/${PF}"
210 # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes 276 # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes
211 # it's better if the configure chatter is in the build logs: 277 # it's better if the configure chatter is in the build logs:
212 cabalconf="${cabalconf} --verbose" 278 cabalconf="${cabalconf} --verbose"
213 fi
214 # Note: with Cabal-1.1.6.x we do not have enough control
215 # to put the docs into the right place. They're currently going
216 # into /usr/share/${P}/ghc-x.y/doc/
217 # rather than /usr/share/doc/${PF}/
218 # Because we can only set the datadir, not the docdir.
219 279
280 # We build shared version of our Cabal where ghc ships it's shared
281 # version of it. We will link ./setup as dynamic binary againt Cabal later.
282 [[ ${CATEGORY}/${PN} == "dev-haskell/cabal" ]] && \
283 $(ghc-supports-shared-libraries) && \
284 cabalconf="${cabalconf} --enable-shared"
285
220 ./setup configure \ 286 set -- configure \
221 --ghc --prefix=/usr \ 287 --ghc --prefix="${EPREFIX}"/usr \
222 --with-compiler="$(ghc-getghc)" \ 288 --with-compiler="$(ghc-getghc)" \
223 --with-hc-pkg="$(ghc-getghcpkg)" \ 289 --with-hc-pkg="$(ghc-getghcpkg)" \
224 --prefix=/usr \ 290 --prefix="${EPREFIX}"/usr \
225 --libdir=/usr/$(get_libdir) \ 291 --libdir="${EPREFIX}"/usr/$(get_libdir) \
226 --libsubdir=${P}/ghc-$(ghc-version) \ 292 --libsubdir=${P}/ghc-$(ghc-version) \
227 --datadir=/usr/share/ \ 293 --datadir="${EPREFIX}"/usr/share/ \
228 --datasubdir=${P}/ghc-$(ghc-version) \ 294 --datasubdir=${P}/ghc-$(ghc-version) \
229 ${cabalconf} \ 295 ${cabalconf} \
230 ${CABAL_CONFIGURE_FLAGS} \ 296 ${CABAL_CONFIGURE_FLAGS} \
297 ${CABAL_EXTRA_CONFIGURE_FLAGS} \
298 "$@"
299 echo ./setup "$@"
231 "$@" || die "setup configure failed" 300 ./setup "$@" || die "setup configure failed"
232} 301}
233 302
234cabal-build() { 303cabal-build() {
235 unset LANG LC_ALL LC_MESSAGES 304 unset LANG LC_ALL LC_MESSAGES
236 ./setup build \ 305 set -- build ${CABAL_EXTRA_BUILD_FLAGS} "$@"
306 echo ./setup "$@"
307 ./setup "$@" \
237 || die "setup build failed" 308 || die "setup build failed"
238} 309}
239 310
240cabal-copy() { 311cabal-copy() {
241 ./setup copy \ 312 has "${EAPI:-0}" 0 1 2 && ! use prefix && ED=${D}
242 --destdir="${D}" \ 313
314 set -- copy --destdir="${D}" "$@"
315 echo ./setup "$@"
243 || die "setup copy failed" 316 ./setup "$@" || die "setup copy failed"
244 317
245 # cabal is a bit eager about creating dirs, 318 # cabal is a bit eager about creating dirs,
246 # so remove them if they are empty 319 # so remove them if they are empty
247 rmdir "${D}/usr/bin" 2> /dev/null 320 rmdir "${ED}/usr/bin" 2> /dev/null
248
249 # GHC 6.4 has a bug in get/setPermission and Cabal 1.1.1 has
250 # no workaround.
251 # set the +x permission on executables
252 if [[ -d "${D}/usr/bin" ]] ; then
253 chmod +x "${D}/usr/bin/"*
254 fi
255 # TODO: do we still need this?
256} 321}
257 322
258cabal-pkg() { 323cabal-pkg() {
259 # This does not actually register since we're using true instead 324 # This does not actually register since we're using true instead
260 # of ghc-pkg. So it just leaves the .installed-pkg-config and we can 325 # of ghc-pkg. So it just leaves the .conf file and we can
261 # register that ourselves (if it exists). 326 # register that ourselves (if it exists).
262 local result
263 local err
264 327
265 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then 328 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then
266 if version_is_at_least "1.2.0" "$(cabal-version)"; then
267 # Newer cabal can generate a package conf for us: 329 # Newer cabal can generate a package conf for us:
268 ./setup register --gen-pkg-config="${T}/${P}.conf" 330 ./setup register --gen-pkg-config="${T}/${P}.conf"
269 ghc-setup-pkg "${T}/${P}.conf" 331 ghc-setup-pkg "${T}/${P}.conf"
270 ghc-install-pkg 332 ghc-install-pkg
271 else
272 # With older cabal we have to hack it by replacing its ghc-pkg
273 # with true and then just picking up the .installed-pkg-config
274 # file and registering that ourselves (if it exists).
275 sed -i "s|$(ghc-getghcpkg)|$(type -P true)|" .setup-config
276 ./setup register || die "setup register failed"
277 if [[ -f .installed-pkg-config ]]; then
278 ghc-setup-pkg .installed-pkg-config
279 ghc-install-pkg
280 else
281 die "setup register has not generated a package configuration file"
282 fi
283 fi
284 fi 333 fi
285} 334}
286 335
287# Some cabal libs are bundled along with some versions of ghc 336# Some cabal libs are bundled along with some versions of ghc
288# eg filepath-1.0 comes with ghc-6.6.1 337# eg filepath-1.0 comes with ghc-6.6.1
300} 349}
301 350
302# exported function: check if cabal is correctly installed for 351# exported function: check if cabal is correctly installed for
303# the currently active ghc (we cannot guarantee this with portage) 352# the currently active ghc (we cannot guarantee this with portage)
304haskell-cabal_pkg_setup() { 353haskell-cabal_pkg_setup() {
305 ghc-package_pkg_setup
306 if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]] && ! ghc-sanecabal "${CABAL_MIN_VERSION}"; then
307 eerror "The package dev-haskell/cabal is not correctly installed for"
308 eerror "the currently active version of ghc ($(ghc-version)). Please"
309 eerror "run ghc-updater or haskell-updater or re-build dev-haskell/cabal."
310 die "cabal is not correctly installed"
311 fi
312 if [[ -z "${CABAL_HAS_BINARIES}" ]] && [[ -z "${CABAL_HAS_LIBRARIES}" ]]; then 354 if [[ -z "${CABAL_HAS_BINARIES}" ]] && [[ -z "${CABAL_HAS_LIBRARIES}" ]]; then
313 eerror "QA: Neither bin nor lib are in CABAL_FEATURES." 355 eqawarn "QA Notice: Neither bin nor lib are in CABAL_FEATURES."
314 fi 356 fi
315 if [[ -n "${CABAL_UNKNOWN}" ]]; then 357 if [[ -n "${CABAL_UNKNOWN}" ]]; then
316 ewarn "Unknown entry in CABAL_FEATURES: ${CABAL_UNKNOWN}" 358 eqawarn "QA Notice: Unknown entry in CABAL_FEATURES: ${CABAL_UNKNOWN}"
317 fi 359 fi
318 if cabal-is-dummy-lib; then 360 if cabal-is-dummy-lib; then
319 einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install." 361 einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install."
320 fi 362 fi
321} 363}
322 364
365haskell-cabal_src_configure() {
366 cabal-is-dummy-lib && return
367
368 pushd "${S}" > /dev/null
369
370 cabal-bootstrap
371
372 cabal-configure "$@"
373
374 popd > /dev/null
375}
376
377# exported function: nice alias
378cabal_src_configure() {
379 haskell-cabal_src_configure "$@"
380}
381
323# exported function: cabal-style bootstrap configure and compile 382# exported function: cabal-style bootstrap configure and compile
324cabal_src_compile() { 383cabal_src_compile() {
325 if ! cabal-is-dummy-lib; then 384 # it's a common mistake when one bumps ebuild to EAPI="2" (and upper)
326 cabal-bootstrap 385 # and forgets to separate src_compile() to src_configure()/src_compile().
327 cabal-configure 386 # Such error leads to default src_configure and we lose all passed flags.
387 if ! has "${EAPI:-0}" 0 1; then
388 local passed_flag
389 for passed_flag in "$@"; do
390 [[ ${passed_flag} == --flags=* ]] && \
391 eqawarn "QA Notice: Cabal option '${passed_flag}' has effect only in src_configure()"
392 done
393 fi
394
395 cabal-is-dummy-lib && return
396
397 has src_configure ${HASKELL_CABAL_EXPF} || haskell-cabal_src_configure "$@"
328 cabal-build 398 cabal-build
329 399
330 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then 400 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
401 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
402 # hscolour and haddock
403 cabal-hscolour-haddock
404 else
405 # just haddock
331 cabal-haddock 406 cabal-haddock
332 fi 407 fi
408 else
409 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
410 # just hscolour
411 cabal-hscolour
412 fi
333 fi 413 fi
334} 414}
335 415
336haskell-cabal_src_compile() { 416haskell-cabal_src_compile() {
417 pushd "${S}" > /dev/null
418
337 cabal_src_compile 419 cabal_src_compile "$@"
420
421 popd > /dev/null
422}
423
424haskell-cabal_src_test() {
425 pushd "${S}" > /dev/null
426
427 if cabal-is-dummy-lib; then
428 einfo ">>> No tests for dummy library: ${CATEGORY}/${PF}"
429 else
430 einfo ">>> Test phase [cabal test]: ${CATEGORY}/${PF}"
431 set -- test "$@"
432 echo ./setup "$@"
433 ./setup "$@" || die "cabal test failed"
434 fi
435
436 popd > /dev/null
338} 437}
339 438
340# exported function: cabal-style copy and register 439# exported function: cabal-style copy and register
341cabal_src_install() { 440cabal_src_install() {
441 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
442
342 if cabal-is-dummy-lib; then 443 if ! cabal-is-dummy-lib; then
343 # create a dummy local package conf file for the sake of ghc-updater
344 dodir "$(ghc-confdir)"
345 echo '[]' > "${D}/$(ghc-confdir)/$(ghc-localpkgconf)"
346 else
347 cabal-copy 444 cabal-copy
348 cabal-pkg 445 cabal-pkg
349
350 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
351 if ! version_is_at_least "1.1.6" "$(cabal-version)"; then
352 dohtml -r dist/doc/html/*
353 fi
354 fi 446 fi
355 fi 447
448 # create a dummy local package conf file for haskell-updater
449 # if it does not exist (dummy libraries and binaries w/o libraries)
450 local ghc_confdir_with_prefix="$(ghc-confdir)"
451 # remove EPREFIX
452 dodir ${ghc_confdir_with_prefix#${EPREFIX}}
453 local conf_file="${D}/$(ghc-confdir)/$(ghc-localpkgconf)"
454 [[ -e $conf_file ]] || echo '[]' > "$conf_file" || die
356} 455}
456
357haskell-cabal_src_install() { 457haskell-cabal_src_install() {
458 pushd "${S}" > /dev/null
459
358 cabal_src_install 460 cabal_src_install
359}
360 461
361EXPORT_FUNCTIONS pkg_setup src_compile src_install 462 popd > /dev/null
463}
464
465# ebuild.sh:use_enable() taken as base
466#
467# Usage examples:
468#
469# CABAL_CONFIGURE_FLAGS=$(cabal_flag gui)
470# leads to "--flags=gui" or "--flags=-gui" (useflag 'gui')
471#
472# CABAL_CONFIGURE_FLAGS=$(cabal_flag gtk gui)
473# also leads to "--flags=gui" or " --flags=-gui" (useflag 'gtk')
474#
475cabal_flag() {
476 if [[ -z "$1" ]]; then
477 echo "!!! cabal_flag() called without a parameter." >&2
478 echo "!!! cabal_flag() <USEFLAG> [<cabal_flagname>]" >&2
479 return 1
480 fi
481
482 local UWORD=${2:-$1}
483
484 if use "$1"; then
485 echo "--flags=${UWORD}"
486 else
487 echo "--flags=-${UWORD}"
488 fi
489
490 return 0
491}

Legend:
Removed from v.1.18  
changed lines
  Added in v.1.31

  ViewVC Help
Powered by ViewVC 1.1.20